/**
 * 解析
 * @param event识别的地址
 * @returns <obj>
 */
let addressList = []; //地址列表




/**
 * 地址数据处理
 * @param addressList-各级数据对象
 * @param index-对应的省/市/县区/街道
 * @param province-只有直辖市会处理为  北京市北京市
 * @returns <array>
 */
function formatAddresList(addressList, index, province) {
  if (index === 1) {
    //省
    addressList.province = addressList.name;
    addressList.type = "province";
  }
  if (index === 2) {
    //市
    if (addressList.name == "市辖区") {
      addressList.name = province.name;
    }
    addressList.city = addressList.name;
    addressList.type = "city";
  }
  if (index === 3) {
    //区或者县
    addressList.county = addressList.name;
    addressList.type = "county";
  }
  if (index === 4) {
    //街道
    addressList.street = addressList.name;
    addressList.type = "street";
  }
  // if (addressList.city) {
  //   index++;
  //   addressList.city.forEach((res) => {
  //     formatAddresList(res, index, addressList);
  //   });
  // }
}

function smart(event, list) {
  addressList = list
  let copy = event;
  let _phone = copy.match(
    /((\d{2,4}[-_－—])\d{3,8}([-_－—]?\d{3,8})?([-_－—]?\d{1,7})?)|(0?1\d{10})/g
  );
  if (_phone && _phone.length > 0) {
    event = event.replace(_phone[0], '')
  }
  event = stripscript(event) //过滤特殊字符
  let obj = {}
  let copyaddress = JSON.parse(JSON.stringify(event))
  copyaddress = copyaddress.split(" ")
  copyaddress.forEach((item, index) => {
    if (item) {
      if (item.length == 1) {
        res += "XX" // 过滤掉一位的名字或者地址
      }
      let addressObj = smatrAddress(item)
      obj = Object.assign(obj, addressObj)
      if (JSON.stringify(addressObj) === "{}") {
        obj.name = item.replace("XX", "")
      }
    }
  })
  if (!obj.phone && _phone) {
    _phone.forEach((e) => {
      if (e.length >= 8) {
        obj.phone = e;
      }
    });
  }
  return obj
}

function smatrAddress(event) {
  let smartObj = {}
  let address = event
  address = stripscript(address) // 过滤特殊字符
  //身份证号匹配
  if (IdentityCodeValid(address)) {
    smartObj.idCard = address
    address = address.replace(address, "")
  }

  //电话匹配
  let phone = address.match(
    /(86-[1][0-9]{10}) | (86[1][0-9]{10})|([1][0-9]{10})/g
  );
  if (phone) {
    smartObj.phone = phone[0];
    address = address.replace(phone[0], "")
  }

  let matchAddress = ""
  //省匹配 比如输入北京市朝阳区，会用北  北京  北京市 北京市朝 以此类推在addressList里的province中做匹配，会得到北京市  河北省 天津市等等；
  let matchProvince = [] //粗略匹配上的省份
  // for (let begIndex = 0; begIndex < address.length; begIndex++) {
  matchAddress = ""
  for (let endIndex = 0; endIndex < address.length; endIndex++) {
    matchAddress = address.slice(0, endIndex + 2)
    addressList.forEach(res => {
      if (res["name"].indexOf(matchAddress) != -1) {
        matchProvince.push({
          province: res.province,
          provinceId: res.id,
          matchValue: matchAddress
        })
      }
    })
  }
  //统计筛选初略统计出的省份
  matchProvince.forEach(item => {
    item.index = 0
    matchProvince.forEach(el => {
      if (item.province == el.province) {
        el.index++
        if (item.matchValue.length > el.matchValue.length) {
          el.matchValue = item.matchValue
        }
      }
    })
  })
  if (matchProvince.length != 0) {
    let province = matchProvince.reduce((p, v) => (p.index < v.index ? v : p));
    smartObj.province = province.matchValue
    smartObj.provinceId = province.provinceId
    address = address.replace(province.matchValue, "");
  }
  // 直辖市边界处理
  if (
    smartObj.province == "北京" ||
    smartObj.province == "天津" ||
    smartObj.province == "上海" ||
    smartObj.province == "重庆"
  ) {
    if (address.length > 0) {
			if (address.slice(0, 1) == '市') {
				address = address.slice(1)
			} if(address.indexOf(smartObj.province) != -1) {
				address = address
			} else {
				address = `${smartObj.province}市${address}`
				console.log(address)
			}
		}
  }

  // 市查找
  let matchCity = []; //粗略匹配上的市
  matchAddress = ""
  for (let endIndex = 0; endIndex < address.length; endIndex++) {
    matchAddress = address.slice(0, endIndex + 2)
    addressList.forEach(el => {
      if (el.id == smartObj.provinceId || !smartObj.provinceId) {
        el.city.forEach(item => {
          if (item["name"].indexOf(matchAddress) != -1) {
            // if(item["name"] == matchAddress) {
            matchCity.push({
              city: item.name,
              cityId: item.id,
              matchValue: matchAddress,
              province: el.province,
              provinceId: el.id
            })
          }
        })
      }
    })
  }
  // 统计筛选初略统计出的市
  matchCity.forEach(item => {
    item.index = 0
    matchCity.forEach((el) => {
      if (item.city == el.city) {
        el.index++
        if (item.matchValue.length > el.matchValue.length) {
          el.matchValue = item.matchValue
        }
      }
    })
  })
  if (matchCity.length != 0) {
    let city = matchCity.reduce((p, v) => (p.index < v.index ? v : p))
    smartObj.city = city.city
    smartObj.cityId = city.cityId
    if (!smartObj.province) {
      smartObj.province = city.province
      smartObj.provinceId = city.provinceId
    }
    address = address.replace(city.matchValue, "");
  }

  //区县查找
  let matchArea = [] //粗略匹配上的区县
  matchAddress = ""
  for (let endIndex = 0; endIndex < address.length; endIndex++) {
    matchAddress = address.slice(0, endIndex + 2)
    addressList.forEach(el => {
      el.city.forEach(item => {
				if (item.name === smartObj.city) {
					item.area.forEach(res => {
						if (res["name"].indexOf(matchAddress) != -1) {
							matchArea.push({
								area: res.name,
								areaId: res.id,
								city: item.name,
								cityId: item.id,
								province: el.name,
								provinceId: el.id,
								matchValue: matchAddress
							})
						}
					})
				}
			})
    })
  }
  // 统计筛选初略统计出的区县
  matchArea.forEach((res) => {
    res.index = 0;
    matchArea.forEach((el) => {
      if (res.city == el.city) {
        el.index++;
        if (res.matchValue.length > el.matchValue.length) {
          el.matchValue = res.matchValue
        }
      }
    })
  })
  if (matchArea.length != 0) {
    let city = matchArea.reduce((p, v) => (p.index < v.index ? v : p))
    smartObj.area = city.area
    smartObj.areaId = city.areaId
    if (!smartObj.province) {
      smartObj.province = city.province
      smartObj.provinceId = city.provinceId
    }
    if (!smartObj.city) {
      smartObj.city = city.city
      smartObj.cityId = city.cityId
    }
    address = address.replace(city.matchValue, "");
  }
  if (smartObj.province) {
    smartObj.address = address;
  }
  // if(smartObj.province) {
  //   // const address_detail_list = ['室', '楼', '元', '幢', '门', '户']
  //   const addressArr = address.split(' ')
  //   for(let i in addressArr) {
  //     for(let j in address_detail_list) {
  //       if(addressArr[i].lastIndexOf(address_detail_list[j]) > -1) {
  //         const buildIndex = addressArr[i]

  //         // const reg = new RegExp('\\d*' + address_detail_list[j])
  //         const reg = new RegExp(`\\d+(?=${address_detail_list[j]})*`)
  //         if(reg.exec(addressArr[i])) {
  //           const buildIndex = addressArr[i].search(reg)
  //           const detailIndex = addressArr[i].indexOf(address_detail_list[j])
  //           // 详细地址
  //           address = addressArr[i].substring(0, buildIndex)
  //           console.log(buildIndex+','+detailIndex)
  //           // 门牌号
  //           build = addressArr[i].substring(buildIndex, detailIndex + 1)
  //           smartObj.address = address
  //           smartObj.build = build 
  //         }
  //       }
  //     }
  //   }
  //   if(!smartObj.address) {
  //       smartObj.address = address
  //       smartObj.build = '' 
  //   }
  // }
  return smartObj
}

//过滤特殊字符
function stripscript(s) {
  s = s.replace(/(\d{3})-(\d{4})-(\d{4})/g, "$1$2$3");
  s = s.replace(/(\d{3}) (\d{4}) (\d{4})/g, "$1$2$3");
  var pattern = new RegExp(
    "[`~!@#$^&*()=|{}':;',\\[\\].<>/?~！@#￥……&*（）——|{}【】‘；：”“’。，、？-]"
  );
  var rs = "";
  for (var i = 0; i < s.length; i++) {
    rs = rs + s.substr(i, 1).replace(pattern, " ");
  }
  rs = rs.replace(/[\r\n]/g, "");
  return rs;
}

// 身份证号码验证
function IdentityCodeValid(code) {
  let pass;
  var city = {
    11: "北京",
    12: "天津",
    13: "河北",
    14: "山西",
    15: "内蒙古",
    21: "辽宁",
    22: "吉林",
    23: "黑龙江 ",
    31: "上海",
    32: "江苏",
    33: "浙江",
    34: "安徽",
    35: "福建",
    36: "江西",
    37: "山东",
    41: "河南",
    42: "湖北 ",
    43: "湖南",
    44: "广东",
    45: "广西",
    46: "海南",
    50: "重庆",
    51: "四川",
    52: "贵州",
    53: "云南",
    54: "西藏 ",
    61: "陕西",
    62: "甘肃",
    63: "青海",
    64: "宁夏",
    65: "新疆",
    71: "台湾",
    81: "香港",
    82: "澳门",
    91: "国外 ",
  };
  var tip = "";
  pass = true;

  if (!code || !/^\d{17}(\d|X)$/i.test(code)) {
    tip = "身份证号格式错误";
    pass = false;
  } else if (!city[code.substr(0, 2)]) {
    tip = "地址编码错误";
    pass = false;
  } else {
    //18位身份证需要验证最后一位校验位
    if (code.length == 18) {
      code = code.split("");
      //∑(ai×Wi)(mod 11)
      //加权因子
      var factor = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
      //校验位
      var parity = [1, 0, "X", 9, 8, 7, 6, 5, 4, 3, 2];
      var sum = 0;
      var ai = 0;
      var wi = 0;
      for (var i = 0; i < 17; i++) {
        ai = code[i];
        wi = factor[i];
        sum += ai * wi;
      }
      var last = parity[sum % 11];
      if (parity[sum % 11] != code[17]) {
        tip = "校验位错误";
        pass = false;
      }
    }
  }
  return pass;
}

module.exports = {
  smart: smart
}


